#include <stdio.h>
#include <unistd.h>
#include <pthread.h>
#include <cv.h>
#include <highgui.h>
#include <sys/time.h>
#include "key_watch.h"
#include "flag.h"

static void *thread_code(void*);
static pthread_t task_id;

void *thread_code(void *t){
	char key;

	printf("ket watch thread start\n");

	while(1){
		scanf("%c",&key);
		printf("ket pushed  key=%c\n",key);
		if( key == 'q' || key == '2' ) {
			quit_flag = 1;
			break;
		}
		usleep(100*1000);
	}

	return 0;
}


int key_watch_create(){
	int policy;
	struct sched_param param;
	
	// スレッドの生成
	if(pthread_create(&task_id, NULL, thread_code, NULL) != 0){
		printf("failed to create circle thread\n");
		return -1;
	}
	
	// スレッドパラメータの確認
	pthread_getschedparam(task_id, &policy, &param);
	printf("key_watch thread created (plicy = %s, priority = %d)\n",
		((policy == SCHED_FIFO) ? "SCHED_FIFO" : (policy == SCHED_RR) ? "SCHED_RR" : (policy == SCHED_OTHER) ? "SCHED_OTHER" : "???"),
		param.sched_priority);

	//printf("quit_flag = %d",&quit_flag);

	return 0;
}

void key_watch_cancel(){
	pthread_cancel(task_id);
	printf("circle thread canceled\n");
}

