#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <unistd.h>
#include "circle.h"
#include "io.h"
#include "request.h"
#include "routine.h"
#include "flag.h"
#include "speak.h"
#include "uss.h"
#include "timer.h"

#define ds_long 70
#define ds_short 15

static int io_sw_detection();
static run_state_t run_state;
int speed, dist, dist_tmp;

static int ret;

int routine_home(int course_number, int dist_last){

	static const int speed_str = 20;
	static const int speed_rot = 30;

	int dist_long = 70;
	int dist_short = 15;
	const double dist_rot = -90;

	const int delay = 1000;

	int sw_det, uss_det;
	int us_f, us_b, us_l, us_r;

	int dist_state = 1;

	int home_first = 1;

	int dist_tmp_total = 0;

	double volt;
	
	sleep(1);

	/*if(course_number == 1 || course_number == 2){
		dist_state = 1;
	}else{
		dist_state = 2;
	}*/

	while(1){

		if( quit_flag == 1) return 0;
		if(volt <= 0){
			printf("非常停止スイッチが押されました\n");
			//system(line_emergency);
			battery_flag = 1;
			return 0;
		}
							

		printf("\n 帰宅ルーチン開始  \n");
		printf("dist_last = %d\n",dist_last);
		
		ret = 0;
		while (1) {
			switch (dist_state) {
	 			case 1:
					/*if(home_first == 1){
						home_first = 0;
						request_set_runmode(ROT, speed_rot, -180);
						sleep(8);
						request_set_runmode(STR, speed_str, dist_last);
					}else{
						dist_long = ds_long;
						request_set_runmode(STR, speed_str, dist_long);
					}*/
					if(course_number == 1){
						request_set_runmode(ROT, speed_rot, 180);
						sleep(4);
						request_set_runmode(STR, speed_str, dist_last);
					}else{
						request_set_runmode(STR, speed_str, dist_long - dist_last);
					}
					printf(" dist_state = %d\n",dist_state);

					while (1) {
						if( quit_flag == 1) return 0;
						request_get_batt(&volt);
						if(volt <= 0){
							printf("非常停止スイッチが押されました\n");
							//system(line_emergency);
							battery_flag = 1;
							return 0;
						}
							

						sw_det = io_sw_detection();
						if (sw_det == 1) {
							printf("前方スイッチ反応n");
							avoid_flag = 1;
							request_get_runmode(&run_state, &speed, &dist_tmp);
							request_set_runmode(STP, 0, 0);
							sleep(1);
							routine_avoid(avoid_flag);
							dist_tmp_total += dist_tmp;
							if(dist_long - dist_tmp_total > 0){
								request_set_runmode(STR, speed_str, dist_long - dist_tmp_total);
							}else{
								request_set_runmode(STP, 0, 0);
							}
							usleep(1000*delay);
						}
						else if (sw_det == 2) {
							printf("後方スイッチ反応\n");
							avoid_flag = 2;
							request_get_runmode(&run_state, &speed, &dist_tmp);
							request_set_runmode(STP, 0, 0);
							sleep(1);
							routine_avoid(avoid_flag);
							dist_tmp_total += dist_tmp;
							if(dist_long - dist_tmp_total > 0){
								request_set_runmode(STR, speed_str, dist_long - dist_tmp_total);
							}else{
								request_set_runmode(STP, 0, 0);
							}
							usleep(1000*delay);
						}
						else {
							avoid_flag = 0;
						}

						uss_det = uss_detection(&us_f, &us_b, &us_l, &us_r);
						if (uss_det == 1) {
							printf("前方超音波反応\n");
							avoid_flag = 1;
							request_get_runmode(&run_state, &speed, &dist_tmp);
							request_set_runmode(STP, 0, 0);
							sleep(1);
							routine_avoid(avoid_flag);
							dist_tmp_total += dist_tmp;
							if(dist_long - dist_tmp_total > 0){
								request_set_runmode(STR, speed_str, dist_long - dist_tmp_total);
							}else{
								request_set_runmode(STP, 0, 0);
							}
							usleep(1000*delay);
						}
						else if (uss_det == 2) {
							printf("後方超音波反応\n");
							avoid_flag = 2;
							request_get_runmode(&run_state, &speed, &dist_tmp);
							request_set_runmode(STP, 0, 0);
							sleep(1);
							routine_avoid(avoid_flag);
							dist_tmp_total += dist_tmp;
							if(dist_long - dist_tmp_total > 0){
								request_set_runmode(STR, speed_str, dist_long - dist_tmp_total);
							}else{
								request_set_runmode(STP, 0, 0);
							}
							usleep(1000*delay);
						}
						else {
							avoid_flag = 0;
						}

						request_get_runmode(&run_state, &speed, &dist);
						if (run_state == STP) {
							/*if(course_number == 2){
								printf("進路変更\n");
								course_number = 1;
								dist_tmp_total = 0;
								request_set_runmode(STP, 0, 0);
								sleep(1);
								request_set_runmode(ROT, speed_rot, -dist_rot);
								sleep(5);
								break;
							}else{*/
								request_set_runmode(STP, 0, 0);
								sleep(1);
								request_set_runmode(ROT, speed_rot, -dist_rot);
								sleep(5);
								return 0;
							//}
						}
						usleep(1000);
					}
					break;

				case 2:

					if(home_first == 1){
						if(course_number == 3){
							dist_long -= dist_last;
							request_set_runmode(STR, speed_str, dist_long);
						}else{
							dist_short -= dist_last;
							request_set_runmode(STR, speed_str, dist_short);
						}
						home_first = 0;
					}else{
						dist_short = ds_short;
						request_set_runmode(STR, speed_str, dist_short);
					}

					printf(" dist_state = %d\n",dist_state);

					while (1) {
						if( quit_flag == 1) return 0;
						request_get_batt(&volt);
						if(volt <= 0){
							printf("非常停止スイッチが押されました\n");
							//system(line_emergency);
							battery_flag = 1;
							return 0;
						}
							

						sw_det = io_sw_detection();
						if (sw_det == 1) {
							printf("前方スイッチ反応\n");
							avoid_flag = 1;
							request_get_runmode(&run_state, &speed, &dist_tmp);
							request_set_runmode(STP, 0, 0);
							sleep(1);
							routine_avoid(avoid_flag);
							if(dist_short - dist_tmp_total > 0){
								request_set_runmode(STR, speed_str, dist_short - dist_tmp_total);
							}else{
								request_set_runmode(STP, 0, 0);
							}
							usleep(1000*delay);
						}
						else if (sw_det == 2) {
							printf("後方スイッチ反応\n");
							avoid_flag = 2;
							request_get_runmode(&run_state, &speed, &dist_tmp);
							request_set_runmode(STP, 0, 0);
							sleep(1);
							routine_avoid(avoid_flag);
							if(dist_short - dist_tmp_total > 0){
								request_set_runmode(STR, speed_str, dist_short - dist_tmp_total);
							}else{
								request_set_runmode(STP, 0, 0);
							}
							usleep(1000*delay);
						}
						else {
							avoid_flag = 0;
						}

						uss_det = uss_detection(&us_f, &us_b, &us_l, &us_r);
						if (uss_det == 1) {
							printf("前方超音波反応\n");
							avoid_flag = 1;
							request_get_runmode(&run_state, &speed, &dist_tmp);
							request_set_runmode(STP, 0, 0);
							sleep(1);
							routine_avoid(avoid_flag);
							if(dist_short - dist_tmp_total > 0){
								request_set_runmode(STR, speed_str, dist_short - dist_tmp_total);
							}else{
								request_set_runmode(STP, 0, 0);
							}
							usleep(1000*delay);
						}
						else if (uss_det == 2) {
							printf("後方超音波反応\n");
							avoid_flag = 2;
							request_get_runmode(&run_state, &speed, &dist_tmp);
							request_set_runmode(STP, 0, 0);
							sleep(1);
							routine_avoid(avoid_flag);
							if(dist_short - dist_tmp_total > 0){
								request_set_runmode(STR, speed_str, dist_short - dist_tmp_total);
							}else{
								request_set_runmode(STP, 0, 0);
							}
							usleep(1000*delay);
						}
						else {
							avoid_flag = 0;
						}

						request_get_runmode(&run_state, &speed, &dist);
						if (run_state == STP) {
							if(course_number == 3){
								printf("進路変更\n");
								course_number = 1;
								dist_tmp_total = 0;
								request_set_runmode(STP, 0, 0);
								sleep(1);
								request_set_runmode(ROT, speed_rot, dist_rot);
								sleep(5);
								break;
							}else{														
								request_set_runmode(STP, 0, 0);
								sleep(1);
								request_set_runmode(ROT, speed_rot, -180);
								sleep(8);
								return 0;
							}
						}
						usleep(1000);
					}
					break;
				default:
					break;
			}
		}
	}
	return 0;
}


int io_sw_detection(){
	int sw_1, sw_2, sw_3, sw_4, sw_5, sw_6, sw_7, sw_8;
	io_get_sw(&sw_1, &sw_2, &sw_3, &sw_4, &sw_5, &sw_6, &sw_7, &sw_8);
	if(sw_1 == 0 || sw_2 == 0 || sw_3 == 0 || sw_4 == 0 ){
		return 1;
	}

	if(sw_5 == 0 || sw_6 == 0 || sw_7 == 0 || sw_8 == 0 ){
		return 2;
	}

	return 0;
}

