#include <stdio.h>
#include <opencv/highgui.h>
//#include "get_img.h"
#include "camera.h"

int main(){
	char buf[256];
	int device;
	int width = 320;
	int height = 240;
	CvCapture *capture; 

	
	//カメラデバイスの設定 1台目:0、2台目:1
	printf("device number? [ 0 to 3 ]\n");
	fgets(buf, sizeof(buf), stdin);
	sscanf(buf, "%d", &device);

	camera_set(device);
	capture = camera_get_cap(device);

	cvSetCaptureProperty(capture,CV_CAP_PROP_FRAME_WIDTH,width);
	cvSetCaptureProperty(capture,CV_CAP_PROP_FRAME_HEIGHT,height);

	IplImage *image;
	image = cvQueryFrame(capture);
	cvSaveImage("./img/test_input.jpg", image, 0);

	cvReleaseCapture(&capture);

	return 0;
}
