#include <stdio.h>
#include <unistd.h>
#include "circle.h"
#include "camera.h"

int main(){
	int i, cg_x, cg_y, ratio, cir_x, cir_y, radius;
	int device = 0;
	char buf[256];
	//int iteration = 1000;
	int iteration = 100;
	int ret ;

	//カメラデバイスの設定 1台目:0、2台目:1
        printf("device number? [ 0 to 3 ]\n");
        fgets(buf, sizeof(buf), stdin);
        sscanf(buf, "%d", &device);
	
	//if(circle_create() != 0) return -1;
	//if(circle_create2() != 0) return -1;

	ret = camera_set(device);
	if( ret < 0 ){
		printf("camera device [%d] not ready!!!\n",device);
		camera_release();
		return -1;
	}

	if( device == 0){
		circle_camera_set();
	}

	//circle_detect();
	//sleep(2);

/*
	for(i = 0; i < iteration; i++){
		circle_detect();
		//usleep(10*1000);
	}
*/


	if(device == 0){
		if(circle_create() != 0) return -1;
		sleep(1);
		for(i = 0; i < iteration; i++){
			circle_get_cg(&cg_x, &cg_y, &ratio);
			circle_get_cir(&cir_x, &cir_y, &radius);
			printf("count[%d] : cg_x  = %3d, cg_y = %3d, ratio  = %3d\n", i, cg_x, cg_y, ratio);
			printf("         : cir_x = %3d, radius = %3d\n", cir_x, radius);
			usleep(1000 * 1000);
		}
		circle_cancel();
	}
	
	camera_release();

	return 0;
}
