#include <stdio.h>

#include <unistd.h>
#include <time.h>
#include <pthread.h>
#include "flag.h"
#include "timer2.h"

#define MIN_HOME 1	//default 45
#define MIN_RUN  2	//default 10

static void *thread_code(void*);

static pthread_t task_id;

time_t timer;
struct tm *t_st;
int tmp_min;



//volatile int trash_timer = 1;

//Xbh֘A
int timer2_srd_create() {
	int policy;
	struct sched_param param;
	// Xbh̐
	if (pthread_create(&task_id, NULL, thread_code, NULL) != 0) {
		printf("failed to create timer2 thread\n");
		return -1;
	}
	// Xbhp[^̊mF
	pthread_getschedparam(task_id, &policy, &param);
	printf("timer thread2 created (plicy = %s, priority = %d)\n",
		((policy == SCHED_FIFO) ? "SCHED_FIFO" : (policy == SCHED_RR) ? "SCHED_RR" : (policy == SCHED_OTHER) ? "SCHED_OTHER" : "???"),
		param.sched_priority);
	return 0;
}

//ԂŏԂω
void timer2_std() {

	const int cycle = 10 ;	// s[ms]
	time(&timer);	//timerɌݎ̏
	t_st = localtime(&timer);	//timeret_stɑ
	tmp_min = (t_st->tm_min) + MIN_RUN;	//tmp_minɎ̖ڕW()
	if (tmp_min >= 60) {
		tmp_min -= 60;
	}
	//printf("Next is %d:00\n",tmp_min);
		
	while(1){
		time(&timer);	//timerɌݎ̏
		t_st = localtime(&timer);	//timeret_stɑ
		printf("\r[time is %d:%d, trash_timer = %d]  ", t_st->tm_min, t_st->tm_sec, trash_timer);
		
		switch (trash_timer) {
			//~->s
			case 0:
				if (t_st->tm_min == tmp_min) {

					trash_timer = 1;	//change trash_timer

					tmp_min = (t_st->tm_min) + MIN_RUN;	//tmp_minɎ̖ڕW()
					if (tmp_min >= 60) {
						tmp_min -= 60;
					}
					tmp_min -= 1;
					printf("Next is %d:00\n",tmp_min);
				}
				break;
			//s->~
			case 1:
				if (t_st->tm_min == tmp_min) {

					trash_timer = 0;	//change trash_timer

					tmp_min = (t_st->tm_min) + MIN_HOME;
					if (tmp_min >= 60) {
						tmp_min -= 60;
					}
					printf("Next is %d:00\n",tmp_min);
				}
				break;
			default:
				break;
		}
	usleep(cycle * 1000);
	}
	printf("timer2_std end");
}

void *thread_code(void *t){

	timer2_std(trash_timer);
	return 0;
}

void timer2_cancel(){
	pthread_cancel(task_id);
	//printf("timer2 thread canceled\n");
}


